<?php

namespace App\Http\Controllers\Api;

use App\Model\Screen;
use App\Service\ScreenService;
use Illuminate\Http\Request;

class ScreenController extends BaseController
{
    public function add(Request $request)
    {
        $service = new ScreenService();
        $userData = $request->userData->toArray();
        list($status,$data) = $service->add($request->all());

        if($status){
            return $this->json_return(200,'',$data);
        }else{
            return $this->json_return(201,$data);
        }
    }

    public function edit(Request $request)
    {
        $service = new ScreenService();
        $userData = $request->userData->toArray();
        list($status,$data) = $service->edit($request->all());

        if($status){
            return $this->json_return(200,'',$data);
        }else{
            return $this->json_return(201,$data);
        }
    }

    public function del(Request $request)
    {
        $service = new ScreenService();
        $userData = $request->userData->toArray();
        list($status,$data) = $service->del($request->all());

        if($status){
            return $this->json_return(200,'',$data);
        }else{
            return $this->json_return(201,$data);
        }
    }

    public function orderList(Request $request)
    {
        $service = new ScreenService();
        $userData = $request->userData->toArray();
        list($status,$data) = $service->orderList($request->all());

        if($status){
            return $this->json_return(200,'',$data);
        }else{
            return $this->json_return(201,$data);
        }
    }

    public function screenDeviceList(Request $request)
    {
        $service = new ScreenService();
        $userData = $request->userData->toArray();
        list($status,$data) = $service->screenDeviceList($request->all());

        if($status){
            return $this->json_return(200,'',$data);
        }else{
            return $this->json_return(201,$data);
        }
    }

    public function screenDevice(Request $request)
    {
        $service = new ScreenService();
        $userData = $request->userData->toArray();
        list($status,$data) = $service->screenDevice($request->all());

        if($status){
            return $this->json_return(200,'',$data);
        }else{
            return $this->json_return(201,$data);
        }
    }

    public function screenRemoveDevice(Request $request)
    {
        $service = new ScreenService();
        $userData = $request->userData->toArray();
        list($status,$data) = $service->screenRemoveDevice($request->all());

        if($status){
            return $this->json_return(200,'',$data);
        }else{
            return $this->json_return(201,$data);
        }
    }

    public function screenDeviceDataRealTimeList(Request $request){
        $service = new ScreenService();
        $userData = $request->userData->toArray();
        list($status,$data) = $service->screenDeviceDataRealTimeList($request->all());

        if($status){
            return $this->json_return(200,'',$data);
        }else{
            return $this->json_return(201,$data);
        }
    }

    public function screenHistoryList(Request $request){
        $service = new ScreenService();
        $userData = $request->userData->toArray();
        list($status,$data) = $service->screenHistoryList($request->all());

        if($status){
            return $this->json_return(200,'',$data);
        }else{
            return $this->json_return(201,$data);
        }
    }

    public function screenGps(Request $request){
        $service = new ScreenService();
        $userData = $request->userData->toArray();
        list($status,$data) = $service->screenGps($request->all());

        if($status){
            return $this->json_return(200,'',$data);
        }else{
            return $this->json_return(201,$data);
        }
    }

    public function uploadScreenFile(Request $request){
        $service = new ScreenService();
        $userData = $request->userData->toArray();
        list($status,$data) = $service->uploadScreenFile($request->file('file'));

        if($status){
            return $this->json_return(200,'上传成功',['url' => $data]);
        }else{
            return $this->json_return(201,$data);
        }
    }

    //获取文件的位置
    public function getFile($file_name){
        $path = storage_path() . "/app/public/screen/".$file_name;
        $ext = '';
        foreach (Screen::FILE_TYPE as $value){
            if(file_exists($path. '.' . $value)){
                $ext = $value;
            }
        }
        if(empty($ext)) return '';
        return response()->file($path.'.'.$ext);
    }
}
